import java.util.Arrays; class Solution { public int findLengthOfLCIS(int[] nums) { /** * dp[i]定义为以nums[i]结尾的最长连续递增子序列 * 每个数字自己都可以构成一个序列,因此初始化长度都为1 * 因为要连续,所以只和前一个数字比较,一层for循环就够了 */ int[] dp = new int[nums.length]; Arrays.fill(dp, 1); int max = 1; for (int i = 1; i < nums.length; i++) { if (nums[i] > nums[i - 1]){ dp[i] = dp[i - 1] + 1; } max = Math.max(max, dp[i]); } return max; } } /** * 时间复杂度 O(n) * 空间复杂度 O(n) */
class Solution { public int findLengthOfLCIS(int[] nums) { int max = 1; int res = 1; /** * 每次找到连续的子序列,max就加1,然后更新最大的长度res * 如果遇到了递减,就重置max为1,而上一次的最大值已经更新过了 */ for (int i = 1; i < nums.length; i++) { if (nums[i] > nums[i - 1]){ max++; } else { max = 1; } res = Math.max(res, max); } return res; } } /** * 时间复杂度 O(n) * 空间复杂度 O(1) */
https://leetcode-cn.com/problems/longest-continuous-increasing-subsequence/